import { ASTv1 } from '@glimmer/syntax';
import { ExtendedPluginBuilder } from './js-utils';
export interface EmberTemplateCompiler {
    precompile(templateString: string, options: PreprocessOptions): string;
    _buildCompileOptions(options: PreprocessOptions): PreprocessOptions;
    _print(ast: ASTv1.Template, options?: {
        entityEncoding?: 'transformed' | 'raw';
    }): string;
    _preprocess(src: string, options?: PreprocessOptions): ASTv1.Template;
}
export interface PreprocessOptions {
    contents: string;
    moduleName: string;
    plugins?: {
        ast?: ExtendedPluginBuilder[];
    };
    filename?: string;
    parseOptions?: {
        srcName?: string;
        ignoreStandalone?: boolean;
    };
    mode?: 'codemod' | 'precompile';
    strictMode?: boolean;
    locals?: string[];
}
export declare function assertTemplateCompiler(emberTemplateCompiler: any): asserts emberTemplateCompiler is EmberTemplateCompiler;
